<?php
/**
 * Created by PhpStorm.
 * User: robin
 * Date: 9/27/15
 * Time: 1:51 AM
 */

namespace Luticate\Auth\Business;

use Luticate\Utils\Controller\LuticateApplication;

class JwtHelper
{
    const EXPIRATION_KEY =  "expiration_date";
    const SETTING_MCRYPT_KEY = "MCRYPT_KEY";
    const SETTING_JWT_KEY = "JWT_KEY";
    const CRYPT_METHOD = "AES-256-CBC";

    public static function decode($token)
    {
        $app = LuticateApplication::getInstance();
        try
        {
            $key = $app->getSetting(static::SETTING_MCRYPT_KEY);
            $iv = substr($key, 0, 16);
            $jwt = openssl_decrypt(base64_decode($token), static::CRYPT_METHOD, $key, 0, $iv);
            $data = (array)\JWT::decode($jwt, $app->getSetting(static::SETTING_JWT_KEY), ['HS256']);
        }
        catch (\Exception $e)
        {
            return null;
        }

        $expiration_date = array_key_exists(static::EXPIRATION_KEY, $data) ? $data[static::EXPIRATION_KEY] : null;
        if (!is_numeric($expiration_date) || $expiration_date < time()) {
            return null;
        }

        return $data;
    }

    public static function encode($data, $session_time)
    {
        $app = LuticateApplication::getInstance();
        $date = new \DateTime("now", new \DateTimeZone("Europe/Paris"));
        $date->modify("+${session_time} day");
        $data[static::EXPIRATION_KEY] = $date->getTimestamp();
        $jwt = \JWT::encode($data, $app->getSetting(static::SETTING_JWT_KEY));
        $key = $app->getSetting(static::SETTING_MCRYPT_KEY);
        $iv = substr($key, 0, 16);

        return base64_encode(openssl_encrypt($jwt, static::CRYPT_METHOD, $key, 0, $iv));
    }
}