<?php
/**
 * Created by PhpStorm.
 * User: robin
 * Date: 7/2/16
 * Time: 10:54 PM
 */

namespace Luticate\Auth\Middleware;

use Luticate\Auth\Business\LuUsersBusiness;
use Luticate\Utils\Business\LuBusiness;
use Luticate\Utils\Middleware\LuAbstractMiddleware;

class LuAuthMiddleware implements LuAbstractMiddleware
{
    const TOKEN_HEADER = "X-Luticate-Token";
    
    public function onBefore($_parameters, $_headers, $permissions = [])
    {
        $token = $_headers[self::TOKEN_HEADER] ?? null;

        $user = LuUsersBusiness::getUserFromToken($token);

        if ($user->getId() === 0 && !empty($token)) {
            LuBusiness::unauthorized("Invalid token");
        }

        $_parameters["_user"] = $user;

        LuUsersBusiness::checkUserPermissions($user, $permissions);

        return $_parameters;
    }
}